#include <signal.h>
#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

void* bogo_check(void* p)
{
    (void)p;
    char *a[] = { "bogofilter", "-vxd", NULL };

    pid_t pid = fork();
    switch (pid) {
	case 0: /* child */
	    close(0);
	    if (open("spam.eml", O_RDONLY) < 0) { perror("open"); _exit(EXIT_FAILURE); }
	    execvp(a[0], a);
	    perror("execvp");
	    _exit(127);

	case -1: /* failure */
	    perror("fork");
	    return (void *)-1;

	default:
	    break;
    }

    int status;
    if (waitpid(pid, &status, 0) != pid) {
	perror("waitpid");
	return (void *)-1;
    }
    return (void *)status;
}

#define COUNTOF(a) (sizeof(a)/sizeof((a)[0]))

int main(void)
{
    pthread_t ids[52];
    int i;

    signal(SIGPIPE, SIG_IGN);
    for (i = 0; i < COUNTOF(ids); i ++){
	int j = pthread_create(&ids[i], NULL, bogo_check, NULL);
	if (j) {
	    perror("pthread_create");
	    exit(EXIT_FAILURE);
	} else {
	    printf("started thread #%d id %p\n", i, (void *)ids[i]);
	}
    }
    for (i = 0; i < COUNTOF(ids); i ++){
	void *heck;
	int j = pthread_join(ids[i], &heck);
	if (j) {
	    perror("pthread_join");
	} else {
	    printf("checked %d, got %d (sig %d exit %d)!\n", i, (int)heck, (int)heck & 0x7f, (int)heck >> 8);
	}
    }
    return EXIT_SUCCESS;
}
